From c927d94df0fdc59c25961505a5438b0dfc58710a Mon Sep 17 00:00:00 2001
From: Balint Reczey <balint.reczey@canonical.com>
Date: Fri, 9 Mar 2018 15:19:43 +0100
Subject: [PATCH 3/4] dpkg: Support Zstandard compressed packages with multiple
 frames

---
 lib/dpkg/compress.c  | 10 ++++++++--
 t-func/deb-format.at |  2 +-
 2 files changed, 9 insertions(+), 3 deletions(-)

diff --git a/lib/dpkg/compress.c b/lib/dpkg/compress.c
index e20add3b7..2d804818f 100644
--- a/lib/dpkg/compress.c
+++ b/lib/dpkg/compress.c
@@ -774,8 +774,6 @@ decompress_zstd(int fd_in, int fd_out, const char *desc)
     ohshit(_("ZSTD_createDStream() error "));
   }
 
-  /* TODO: a file may consist of multiple appended frames (ex : pzstd).
-   * The following implementation decompresses only the first frame */
   init_result = ZSTD_initDStream(dstream);
   if (ZSTD_isError(init_result)) {
     ohshit(_("ZSTD_initDStream() error : %s"), ZSTD_getErrorName(init_result));
@@ -791,6 +789,14 @@ decompress_zstd(int fd_in, int fd_out, const char *desc)
                ZSTD_getErrorName(to_read));
       }
       fd_write(fd_out, output.dst, output.pos);
+      /* possible next frame */
+      if (to_read == 0) {
+        init_result = ZSTD_initDStream(dstream);
+        if (ZSTD_isError(init_result)) {
+          ohshit(_("ZSTD_initDStream() error : %s"), ZSTD_getErrorName(init_result));
+        }
+        to_read = init_result;
+      }
     }
   }
 
diff --git a/t-func/deb-format.at b/t-func/deb-format.at
index d9ca8b2c5..0296c1d04 100644
--- a/t-func/deb-format.at
+++ b/t-func/deb-format.at
@@ -28,7 +28,7 @@ xz -c control.tar >control.tar.xz
 xz -c data.tar >data.tar.xz
 bzip2 -c data.tar >data.tar.bz2
 lzma -c data.tar >data.tar.lzma
-zstd -q -c data.tar >data.tar.zst
+pzstd -q -c data.tar >data.tar.zst
 touch _ignore
 touch unknown
 ])
-- 
2.15.1

